

   MEMBER('TxaParserTest.clw')                             ! This is a MEMBER module

                     MAP
                       INCLUDE('TXAPARSERTEST001.INC'),ONCE        !Local module procedure declarations
                     END


Main PROCEDURE
  CODE
  GlobalErrors.ThrowMessage(Msg:ProcedureToDo,'Main')      ! This procedure acts as a place holder for a procedure yet to be defined
  SETKEYCODE(0)
  GlobalResponse = RequestCancelled                        ! Request cancelled is the implied action
Test_ParseTXA_OpenFile_ReturnTrue PROCEDURE  (*long addr)  ! Declare Procedure
TestResult  &TestResultT
tr  &TestResult
parser                                  TxaParserClass
q                                       TxaProcedureQueue
dbg                                     debuger
txa                                     string(500)
  CODE
    ! Create a new instance of the class used to pass information
    ! back to the test runner
    TestResult &= new TestResultT
    TestResult.Passed = false ! default to failure
    TestResult.Message = 'Please set an appropriate result message'
    TestResult.ProcedureName = 'Test_ParseTXA_OpenFile_ReturnTrue'
    TestResult.Description = ''
    tr &= TestResult ! So you can use tr or TestResult in your code...
    addr = address(TestResult)
    !dbg.init('TxaParserTest')
    !dbg.debugactive = true
    !dbg.Message('beginning test')
    parser.SetQueue(q)
    !parser.SetDebuger(dbg)
    txa = '..\Invoice\invoice.txa'
    if parser.parse(txa)
        tr.Passed = true
    ELSE
        tr.message = parser.GetLastError()
    END
    ! Before returning you need to set the value of TestResult.Pass.
    ! If the test failed, also set the message to something 
    ! descriptive of the nature of the failure
    !
    ! TestResult.Passed = False
    ! TestResult.Message = 'Expected A, got B'
    return 0
Test_ParseTXA_GetProcedures_VerifyCount PROCEDURE  (*long addr) ! Declare Procedure
TestResult  &TestResultT
tr  &TestResult
parser                                  TxaParserClass
q                                       TxaProcedureQueue
dbg                                     debuger
txa                                     string(500)
  CODE
    ! Create a new instance of the class used to pass information
    ! back to the test runner
    TestResult &= new TestResultT
    TestResult.Passed = false ! default to failure
    TestResult.Message = 'Please set an appropriate result message'
    TestResult.ProcedureName = 'Test_ParseTXA_GetProcedures_VerifyCount'
    TestResult.Description = ''
    tr &= TestResult ! So you can use tr or TestResult in your code...
    addr = address(TestResult)
    parser.SetQueue(q)
    !parser.SetDebuger(dbg)
    txa = '..\Invoice\invoice.txa'
    
    if parser.parse(txa)
        if records(q) = 13
            tr.Passed = true
        ELSE
            tr.message = 'Expected 13 procedures but found ' & records(q)
        END
    ELSE
        tr.message = parser.GetLastError()
    END
    ! Before returning you need to set the value of TestResult.Pass.
    ! If the test failed, also set the message to something 
    ! descriptive of the nature of the failure
    !
    ! TestResult.Passed = False
    ! TestResult.Message = 'Expected A, got B'
    return 0
Test_ParseTXA_GetEmbeds_VerifyCount PROCEDURE  (*long addr) ! Declare Procedure
TestResult  &TestResultT
tr  &TestResult
parser                                  TxaParserClass
q                                       TxaProcedureQueue
dbg                                     debuger
txa                                     string(500)
expectedEmbedCount                      long,dim(20)
x                                       long
  CODE
    ! Create a new instance of the class used to pass information
    ! back to the test runner
    TestResult &= new TestResultT
    TestResult.Passed = false ! default to failure
    TestResult.Message = 'Please set an appropriate result message'
    TestResult.ProcedureName = 'Test_ParseTXA_GetEmbeds_VerifyCount'
    TestResult.Description = ''
    tr &= TestResult ! So you can use tr or TestResult in your code...
    addr = address(TestResult)
    parser.SetQueue(q)
    !parser.SetDebuger(dbg)
    txa = '..\Invoice\invoice.txa'
    if parser.parse(txa)
        
        expectedEmbedCount[1] = 1
        expectedEmbedCount[2] = 1
        expectedEmbedCount[3] = 2
        expectedEmbedCount[4] = 4
        expectedEmbedCount[5] = 1
        expectedEmbedCount[6] = 3
        expectedEmbedCount[7] = 4
        expectedEmbedCount[8] = 3
        expectedEmbedCount[9] = 2
        expectedEmbedCount[10] = 1 
        expectedEmbedCount[11] = 8 
        expectedEmbedCount[12] = 4 
        expectedEmbedCount[13] = 2         
        tr.passed = true 
        loop x = 1 to records(q)
            get(q,x)
            if expectedEmbedCount[x] <> records(q.EmbedQ)
                tr.Message = 'Test failed on index ' & x & ', procname' & q.ProcName & ', count ' & records(q.EmbedQ)
                tr.passed = false
                break
            END
        END        
    ELSE
        tr.message = parser.GetLastError()
    END
    ! Before returning you need to set the value of TestResult.Pass.
    ! If the test failed, also set the message to something 
    ! descriptive of the nature of the failure
    !
    ! TestResult.Passed = False
    ! TestResult.Message = 'Expected A, got B'
    return 0
Test_ParseTXA_WriteEmbedLog_VerifyExistence PROCEDURE  (*long addr) ! Declare Procedure
TestResult  &TestResultT
tr  &TestResult
parser                                          TxaParserClass
q                                               TxaProcedureQueue
txa                                             string(500)
  CODE
    ! Create a new instance of the class used to pass information
    ! back to the test runner
    TestResult &= new TestResultT
    TestResult.Passed = false ! default to failure
    TestResult.Message = 'Please set an appropriate result message'
    TestResult.ProcedureName = 'Test_ParseTXA_WriteEmbedLog_VerifyExistence'
    TestResult.Description = ''
    tr &= TestResult ! So you can use tr or TestResult in your code...
    addr = address(TestResult)
    txa = '..\Invoice\invoice.txa'
    parser.SetQueue(q)
    if parser.parse(txa)
        if parser.Write('ThisIsATestFileAndCanBeDeleted.txt')
            if ~exists('ThisIsATestFileAndCanBeDeleted.txt')
                tr.message = 'Output file was not created'
            ELSE
                tr.passed = true
            END
        else
            tr.message = parser.GetLastError()
        END
        
    ELSE
        tr.message = parser.GetLastError()
    END
    ! Before returning you need to set the value of TestResult.Pass.
    ! If the test failed, also set the message to something 
    ! descriptive of the nature of the failure
    !
    ! TestResult.Passed = False
    ! TestResult.Message = 'Expected A, got B'
    return 0
Test_ParseTXA_ParseTXA_UseDefaultQueue PROCEDURE  (*long addr) ! Declare Procedure
TestResult  &TestResultT
tr  &TestResult
parser              TxaParserClass
q                   TxaProcedureQueue
txa                                     string(500)
  CODE
    ! Create a new instance of the class used to pass information
    ! back to the test runner
    TestResult &= new TestResultT
    TestResult.Passed = false ! default to failure
    TestResult.Message = 'Please set an appropriate result message'
    TestResult.ProcedureName = 'Test_ParseTXA_ParseTXA_UseDefaultQueue'
    TestResult.Description = ''
    tr &= TestResult ! So you can use tr or TestResult in your code...
    addr = address(TestResult)
    txa = '..\Invoice\invoice.txa'
    !---------------------------------------------------------
    ! The following code will crash every time. In the parser
    ! class the default queue creation does not work. Although
    ! the queue is created and assigned in the constructor, by the
    ! time the AddNewProcedure method is called self.procq is
    ! null again. At present the only way to make this class
    ! work (at least in C7) is to declare the queue and pass it in.
    !---------------------------------------------------------
    !if parser.parse(txa)
    !    tr.passed = true
    !END
    tr.message = 'This test has been commented out - see the source.'
    ! Before returning you need to set the value of TestResult.Pass.
    ! If the test failed, also set the message to something 
    ! descriptive of the nature of the failure
    !
    ! TestResult.Passed = False
    ! TestResult.Message = 'Expected A, got B'
    return 0
